import gleam/http.{Get, Post}
import gleam/string_tree
import lustre/element
import switcheroo/login
import switcheroo/picker/page
import wisp.{type Request, type Response}

pub fn picker(req: Request) -> Response {
  case req.method {
    Get -> get_picker(req)
    Post -> post_picker(req)
    _ -> wisp.method_not_allowed([Get, Post])
  }
}

pub fn get_picker(req: Request) -> Response {
  case wisp.get_cookie(req, login.cookie_name, wisp.PlainText) {
    Error(_) ->
      "unauthorized"
      |> string_tree.from_string
      |> wisp.html_response(403)
    Ok(token) ->
      page.picker(
        page.PickerProps([
          page.Member(name: "aki", uuid: "aki1234"),
          page.Member(name: "noe", uuid: "noe1234"),
          page.Member(name: "aurelia", uuid: "aurelia1234"),
        ]),
      )
      |> element.to_document_string
      |> string_tree.from_string
      |> wisp.html_response(200)
  }
}

pub fn post_picker(req: Request) -> Response {
  get_picker(req)
}
