import gleam/dict
import gleam/http.{Get}
import switcheroo/login
import switcheroo/picker
import switcheroo/web
import wisp.{type Request, type Response}

pub fn handle_request(req: Request, ctx: web.Context) -> Response {
  use req <- web.middleware(req, ctx)

  case wisp.path_segments(req) {
    [] -> home_page(req)

    ["login"] -> login.login(req)
    ["picker"] -> picker.picker(req)

    _ -> wisp.not_found()
  }
}

fn home_page(req: Request) -> Response {
  use <- wisp.require_method(req, Get)

  case wisp.get_cookie(req, login.cookie_name, wisp.PlainText) {
    Ok(_) -> {
      echo "got cookie"
      wisp.redirect("/picker")
    }
    Error(e) -> {
      echo "did not get cookie: "
      echo e

      echo req.headers

      wisp.redirect("/login")
    }
  }
}
